## range-v3 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

project(Range-v3 CXX)

find_package(Doxygen)
find_package(Git)

include_directories(include)

enable_testing()
include(CTest)
include(CheckCXXCompilerFlag)
include(CMakeDependentOption)

option(RANGES_MODULES "Enables Clang Modules." OFF)

find_program(MEMORYCHECK_COMMAND valgrind)
if(MEMORYCHECK_COMMAND)
  message("Valgrind: ${MEMORYCHECK_COMMAND}")
  set(MEMORYCHECK_COMMAND_OPTIONS "--trace-children=yes --leak-check=full")
else()
  message("Valgrind not found")
endif()

macro(range_v3_append_flag testname flag)
  check_cxx_compiler_flag(${flag} ${testname})
  if (${testname})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
  endif()
endmacro()

# Select C++ standard to be used for compiling the tests,
# for example: 11, 14, 17, 1z, 1y, ...
#
if(NOT RANGES_CXX_STD)
  # Defaults to C++11 if not set:
  set(RANGES_CXX_STD 11)
endif()

if("x${CMAKE_CXX_COMPILER_ID}" MATCHES "x.*Clang")
  # Clang/C2 will blow up with various parts of the standard library
  # if compiling with -std less than c++14.
  if(("x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC") AND (RANGES_CXX_STD EQUAL 11))
    set(CMAKE_CXX_STANDARD 14)
    set(RANGES_CXX_STD 14)
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${RANGES_CXX_STD} -ftemplate-backtrace-limit=0")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weverything -Werror -pedantic-errors")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-c++98-compat -Wno-c++98-compat-pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-weak-vtables -Wno-padded")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-prototypes -Wno-missing-variable-declarations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-shadow -Wno-old-style-cast")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-documentation -Wno-documentation-unknown-command")
  if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-global-constructors -Wno-exit-time-destructors")
  endif()
  if (RANGES_MODULES)
    if(NOT RANGES_LIBCXX_MODULE)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmodules -fmodule-map-file=${PROJECT_SOURCE_DIR}/include/module.modulemap -fmodules-cache-path=${PROJECT_BINARY_DIR}/module.cache")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmodules -fmodule-map-file=${PROJECT_SOURCE_DIR}/include/module.modulemap -fmodules-cache-path=${PROJECT_BINARY_DIR}/module.cache -fno-implicit-module-maps -fmodule-map-file=${RANGES_LIBCXX_MODULE}")
    endif()
  endif()
  set(CMAKE_CXX_FLAGS_DEBUG "-O0 -fno-inline -g3 -fstack-protector-all")
  set(CMAKE_CXX_FLAGS_RELEASE "-Ofast -g0 -DNDEBUG")
elseif(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${RANGES_CXX_STD} -ftemplate-backtrace-limit=0")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Werror -pedantic-errors")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-overflow")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
    endif()
  elseif((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "7.0") OR (CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL "7.0"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-noexcept-type")
  endif()
  set(CMAKE_CXX_FLAGS_DEBUG "-O0 -fno-inline -g3 -fstack-protector-all")
  set(CMAKE_CXX_FLAGS_RELEASE "-Ofast -g0 -DNDEBUG")
# else()
#   message(FATAL_ERROR "Unknown compiler. Good luck!")
endif()

range_v3_append_flag(RANGE_V3_HAS_MARCH_NATIVE "-march=native")
range_v3_append_flag(RANGE_V3_HAS_MTUNE_NATIVE "-mtune=native")

# Test for <thread>
try_compile(RANGE_V3_TRY_THREAD ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/thread_test_code.cpp)
if(NOT RANGE_V3_TRY_THREAD)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRANGES_CXX_THREAD=0")
endif()

# Test for coroutine TS support
include(CheckCXXSourceCompiles)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/cmake/coro_test_code.cpp" RANGE_V3_CORO_TEST_CODE)
set(CMAKE_REQUIRED_FLAGS "-fcoroutines-ts")
check_cxx_source_compiles("${RANGE_V3_CORO_TEST_CODE}" RANGE_V3_HAS_FCOROUTINES_TS)

if (RANGE_V3_HAS_FCOROUTINES_TS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fcoroutines-ts")
endif()

# Test all headers
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS
                  RELATIVE "${CMAKE_SOURCE_DIR}/include"
                  "${CMAKE_SOURCE_DIR}/include/*.hpp")

# Add header files as sources to fix MSVS 2017 not finding source during debugging
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS_ABSOLUTE
                  "${CMAKE_SOURCE_DIR}/include/*.hpp")

include(TestHeaders)
if(RANGE_V3_NO_HEADER_CHECK)
  add_custom_target(headers SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
else()
  add_custom_target(headers ALL SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
endif()
generate_standalone_header_tests(EXCLUDE_FROM_ALL MASTER_TARGET headers HEADERS ${RANGE_V3_PUBLIC_HEADERS})

# Grab the range-v3 version numbers:
include(${CMAKE_SOURCE_DIR}/Version.cmake)
set(RANGE_V3_VERSION ${RANGE_V3_MAJOR}.${RANGE_V3_MINOR}.${RANGE_V3_PATCHLEVEL})

# Try to build a new version.hpp
configure_file(version.hpp.in include/range/v3/version.hpp @ONLY)
file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp RANGE_V3_OLD_VERSION_HPP)
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3/version.hpp RANGE_V3_NEW_VERSION_HPP)

# If the new version.hpp is materially different from the one in the source
# directory, update it, amend the most recent commit, and tag the commit.
if(NOT RANGE_V3_NEW_VERSION_HPP STREQUAL RANGE_V3_OLD_VERSION_HPP)
  # Check that Version.cmake is the only changed file:
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" status --porcelain -uno
    OUTPUT_VARIABLE RANGE_V3_GIT_STATUS
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  string(REPLACE "\n" ";"  RANGE_V3_GIT_STATUS ${RANGE_V3_GIT_STATUS})
  if (NOT "x${RANGE_V3_GIT_STATUS}" STREQUAL "x M README.md; M Version.cmake")
    message(FATAL_ERROR "Cannot update version.hpp: range-v3 source directory has a dirty status")
  endif()
  file(
    COPY ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp
    DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3
  )
  # Update the conanfiles, too
  configure_file(conanfile.py.in ${CMAKE_CURRENT_SOURCE_DIR}/conanfile.py @ONLY)
  configure_file(test_package/conanfile.py.in ${CMAKE_CURRENT_SOURCE_DIR}/test_package/conanfile.py @ONLY)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" add -u
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" commit --amend --no-edit
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" tag -f -a "${RANGE_V3_VERSION}" -m "${RANGE_V3_VERSION}"
  )
  find_program(CONAN_EXECUTABLE NAMES conan conan.exe)
  if (NOT "x${CONAN_EXECUTABLE}" STREQUAL "xCONAN_EXECUTABLE-NOTFOUND")
    message("Exporting conanfile for new version")
    execute_process(
      COMMAND ${CONAN_EXECUTABLE} export ericniebler/stable
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
  endif()
  message("Version updated to ${RANGE_V3_VERSION}. Don't forget to:")
  message("  git push origin <feature-branch>")
  message("and (after that is merged to master) then:")
  message("  conan export ericniebler")
  message("  conan test_package")
  message("  conan upload --all range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
endif()

add_subdirectory(doc)
add_subdirectory(test)
add_subdirectory(example)
add_subdirectory(perf)

install(DIRECTORY include/ DESTINATION include
        FILES_MATCHING PATTERN "*.hpp")

=== example/CMakeLists.txt ===
add_executable(comprehensions comprehensions.cpp)
add_test(test.example.comprehensions, comprehensions)

# add_executable(fibonacci fibonacci.cpp)
# add_test(test.example.fibonacci, fibonacci)

# Guarded with a variable because the calendar example causes gcc to puke.
if(RANGES_BUILD_CALENDAR_EXAMPLE)
    set(Boost_USE_STATIC_LIBS        ON)
    set(Boost_USE_MULTITHREADED     OFF)
    set(Boost_USE_STATIC_RUNTIME    OFF)
    find_package(Boost 1.59.0 COMPONENTS date_time program_options)

    if (Boost_FOUND)
        include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
        add_executable(calendar calendar.cpp)
        target_link_libraries(calendar ${Boost_LIBRARIES})
        set_target_properties(calendar PROPERTIES COMPILE_FLAGS "-std=gnu++14")
    endif()
endif()

=== perf/CMakeLists.txt ===
add_executable(counted_insertion_sort counted_insertion_sort.cpp)

add_executable(sort_patterns sort_patterns.cpp)

=== test/CMakeLists.txt ===
add_subdirectory(action)
add_subdirectory(algorithm)
add_subdirectory(numeric)
add_subdirectory(utility)
add_subdirectory(view)

add_executable(config config.cpp)
add_test(test.config config)

add_executable(container_conversion container_conversion.cpp)
add_test(test.container_conversion container_conversion)

add_executable(constexpr_core constexpr_core.cpp)
add_test(test.constexpr_core constexpr_core)

add_executable(view_facade view_facade.cpp)
add_test(test.view_facade view_facade)

add_executable(view_adaptor view_adaptor.cpp)
add_test(test.view_adaptor view_adaptor)

add_executable(index index.cpp)
add_test(test.index index)

add_executable(iterator_range iterator_range.cpp)
add_test(test.iterator_range iterator_range)

add_executable(multiple multiple1.cpp multiple2.cpp)
add_test(test.multiple multiple)

add_executable(distance distance.cpp)
add_test(test.distance distance)

add_executable(to_container to_container.cpp)
add_test(test.to_container to_container)

add_executable(getlines getlines.cpp)
add_test(test.getlines getlines)

add_executable(istream_range istream_range.cpp)
add_test(test.istream_range istream_range)

add_executable(bug474 bug474.cpp)
add_test(test.bug474 bug474)

add_executable(bug566 bug566.cpp)
add_test(test.bug566 bug566)

add_executable(span span.cpp)
add_test(test.span span)

add_executable(generator generator.cpp)
add_test(test.generator generator)

=== test/action/CMakeLists.txt ===
add_executable(act.concepts cont_concepts.cpp)
add_test(test.act.concepts act.concepts)

add_executable(act.drop drop.cpp)
add_test(test.act.drop act.drop)

add_executable(act.drop_while drop_while.cpp)
add_test(test.act.drop_while act.drop_while)

add_executable(act.insert insert.cpp)
add_test(test.act.insert act.insert)

add_executable(act.join join.cpp)
add_test(test.act.join act.join)

add_executable(act.push_front push_front.cpp)
add_test(test.act.push_front act.push_front)

add_executable(act.push_back push_back.cpp)
add_test(test.act.push_back act.push_back)

add_executable(act.remove_if remove_if.cpp)
add_test(test.act.remove_if act.remove_if)

add_executable(act.reverse reverse.cpp)
add_test(test.act.reverse act.reverse)

add_executable(act.shuffle shuffle.cpp)
add_test(test.act.shuffle act.shuffle)

add_executable(act.slice slice.cpp)
add_test(test.act.slice act.slice)

add_executable(act.sort sort.cpp)
add_test(test.act.sort act.sort)

add_executable(act.split split.cpp)
add_test(test.act.split act.split)

add_executable(act.stable_sort stable_sort.cpp)
add_test(test.act.stable_sort act.stable_sort)

add_executable(act.stride stride.cpp)
add_test(test.act.stride act.stride)

add_executable(act.take take.cpp)
add_test(test.act.take act.take)

add_executable(act.take_while take_while.cpp)
add_test(test.act.take_while act.take_while)

add_executable(act.transform transform.cpp)
add_test(test.act.transform act.transform)

add_executable(act.unique unique.cpp)
add_test(test.act.unique act.unique)

=== test/algorithm/CMakeLists.txt ===
add_executable(alg.adjacent_find adjacent_find.cpp)
add_test(test.alg.adjacent_find, alg.adjacent_find)

add_executable(alg.all_of all_of.cpp)
add_test(test.alg.all_of, alg.all_of)

add_executable(alg.any_of any_of.cpp)
add_test(test.alg.any_of, alg.any_of)

add_executable(alg.none_of none_of.cpp)
add_test(test.alg.none_of, alg.none_of)

add_executable(alg.binary_search binary_search.cpp)
add_test(test.alg.binary_search, alg.binary_search)

add_executable(alg.copy copy.cpp)
add_test(test.alg.copy, alg.copy)

add_executable(alg.copy_backward copy_backward.cpp)
add_test(test.alg.copy_backward, alg.copy_backward)

add_executable(alg.count count.cpp)
add_test(test.alg.count, alg.count)

add_executable(alg.count_if count_if.cpp)
add_test(test.alg.count_if, alg.count_if)

add_executable(alg.equal equal.cpp)
add_test(test.alg.equal, alg.equal)

add_executable(alg.equal_range equal_range.cpp)
add_test(test.alg.equal_range, alg.equal_range)

add_executable(alg.fill fill.cpp)
add_test(test.alg.fill, alg.fill)

add_executable(alg.find find.cpp)
add_test(test.alg.find, alg.find)

add_executable(alg.find_end find_end.cpp)
add_test(test.alg.find_end, alg.find_end)

add_executable(alg.find_if find_if.cpp)
add_test(test.alg.find_if, alg.find_if)

add_executable(alg.find_first_of find_first_of.cpp)
add_test(test.alg.find_first_of, alg.find_first_of)

add_executable(alg.for_each for_each.cpp)
add_test(test.alg.for_each, alg.for_each)

add_executable(alg.for_each_n for_each_n.cpp)
add_test(test.alg.for_each_n, alg.for_each_n)

add_executable(alg.generate generate.cpp)
add_test(test.alg.generate, alg.generate)

add_executable(alg.generate_n generate_n.cpp)
add_test(test.alg.generate_n, alg.generate_n)

add_executable(alg.includes includes.cpp)
add_test(test.alg.includes, alg.includes)

add_executable(alg.inplace_merge inplace_merge.cpp)
add_test(test.alg.inplace_merge, alg.inplace_merge)

add_executable(alg.is_heap1 is_heap1.cpp)
add_test(test.alg.is_heap1, alg.is_heap1)

add_executable(alg.is_heap2 is_heap2.cpp)
add_test(test.alg.is_heap2, alg.is_heap2)

add_executable(alg.is_heap3 is_heap3.cpp)
add_test(test.alg.is_heap3, alg.is_heap3)

add_executable(alg.is_heap4 is_heap4.cpp)
add_test(test.alg.is_heap4, alg.is_heap4)

add_executable(alg.is_heap_until1 is_heap_until1.cpp)
add_test(test.alg.is_heap_until1, alg.is_heap_until1)

add_executable(alg.is_heap_until2 is_heap_until2.cpp)
add_test(test.alg.is_heap_until2, alg.is_heap_until2)

add_executable(alg.is_heap_until3 is_heap_until3.cpp)
add_test(test.alg.is_heap_until3, alg.is_heap_until3)

add_executable(alg.is_heap_until4 is_heap_until4.cpp)
add_test(test.alg.is_heap_until4, alg.is_heap_until4)

add_executable(alg.is_partitioned is_partitioned.cpp)
add_test(test.alg.is_partitioned, alg.is_partitioned)

add_executable(alg.is_permutation is_permutation.cpp)
add_test(test.alg.is_permutation, alg.is_permutation)

add_executable(alg.is_sorted_until is_sorted_until.cpp)
add_test(test.alg.is_sorted_until, alg.is_sorted_until)

add_executable(alg.is_sorted is_sorted.cpp)
add_test(test.alg.is_sorted, alg.is_sorted)

add_executable(alg.lexicographical_compare lexicographical_compare.cpp)
add_test(test.alg.lexicographical_compare, alg.lexicographical_compare)

add_executable(alg.lower_bound lower_bound.cpp)
add_test(test.alg.lower_bound, alg.lower_bound)

add_executable(alg.make_heap make_heap.cpp)
add_test(test.alg.make_heap, alg.make_heap)

add_executable(alg.max max.cpp)
add_test(test.alg.max, alg.max)

add_executable(alg.max_element max_element.cpp)
add_test(test.alg.max_element, alg.max_element)

add_executable(alg.merge merge.cpp)
add_test(test.alg.merge, alg.merge)

add_executable(alg.min min.cpp)
add_test(test.alg.min, alg.min)

add_executable(alg.min_element min_element.cpp)
add_test(test.alg.min_element, alg.min_element)

add_executable(alg.minmax minmax.cpp)
add_test(test.alg.minmax, alg.minmax)

add_executable(alg.minmax_element minmax_element.cpp)
add_test(test.alg.minmax_element, alg.minmax_element)

add_executable(alg.mismatch mismatch.cpp)
add_test(test.alg.mismatch, alg.mismatch)

add_executable(alg.move move.cpp)
add_test(test.alg.move alg.move)

add_executable(alg.move_backward move_backward.cpp)
add_test(test.alg.move_backward alg.move_backward)

add_executable(alg.next_permutation next_permutation.cpp)
add_test(test.alg.next_permutation alg.next_permutation)

add_executable(alg.nth_element nth_element.cpp)
add_test(test.alg.nth_element alg.nth_element)

add_executable(alg.partial_sort partial_sort.cpp)
add_test(test.alg.partial_sort, alg.partial_sort)

add_executable(alg.partial_sort_copy partial_sort_copy.cpp)
add_test(test.alg.partial_sort_copy, alg.partial_sort_copy)

add_executable(alg.partition partition.cpp)
add_test(test.alg.partition, alg.partition)

add_executable(alg.partition_copy partition_copy.cpp)
add_test(test.alg.partition_copy, alg.partition_copy)

add_executable(alg.partition_point partition_point.cpp)
add_test(test.alg.partition_point, alg.partition_point)

add_executable(alg.pop_heap pop_heap.cpp)
add_test(test.alg.pop_heap alg.pop_heap)

add_executable(alg.prev_permutation prev_permutation.cpp)
add_test(test.alg.prev_permutation alg.prev_permutation)

add_executable(alg.push_heap push_heap.cpp)
add_test(test.alg.push_heap alg.push_heap)

add_executable(alg.remove remove.cpp)
add_test(test.alg.remove, alg.remove)

add_executable(alg.remove_copy remove_copy.cpp)
add_test(test.alg.remove_copy, alg.remove_copy)

add_executable(alg.remove_copy_if remove_copy_if.cpp)
add_test(test.alg.remove_copy_if, alg.remove_copy_if)

add_executable(alg.remove_if remove_if.cpp)
add_test(test.alg.remove_if, alg.remove_if)

add_executable(alg.replace replace.cpp)
add_test(test.alg.replace, alg.replace)

add_executable(alg.replace_copy replace_copy.cpp)
add_test(test.alg.replace_copy, alg.replace_copy)

add_executable(alg.replace_copy_if replace_copy_if.cpp)
add_test(test.alg.replace_copy_if, alg.replace_copy_if)

add_executable(alg.replace_if replace_if.cpp)
add_test(test.alg.replace_if, alg.replace_if)

add_executable(alg.reverse reverse.cpp)
add_test(test.alg.reverse, alg.reverse)

add_executable(alg.reverse_copy reverse_copy.cpp)
add_test(test.alg.reverse_copy, alg.reverse_copy)

add_executable(alg.rotate rotate.cpp)
add_test(test.alg.rotate, alg.rotate)

add_executable(alg.rotate_copy rotate_copy.cpp)
add_test(test.alg.rotate_copy, alg.rotate_copy)

add_executable(alg.sample sample.cpp)
add_test(test.alg.sample, alg.sample)

add_executable(alg.search search.cpp)
add_test(test.alg.search, alg.search)

add_executable(alg.search_n search_n.cpp)
add_test(test.alg.search_n, alg.search_n)

add_executable(alg.set_difference1 set_difference1.cpp)
add_test(test.alg.set_difference1, alg.set_difference1)

add_executable(alg.set_difference2 set_difference2.cpp)
add_test(test.alg.set_difference2, alg.set_difference2)

add_executable(alg.set_difference3 set_difference3.cpp)
add_test(test.alg.set_difference3, alg.set_difference3)

add_executable(alg.set_difference4 set_difference4.cpp)
add_test(test.alg.set_difference4, alg.set_difference4)

add_executable(alg.set_difference5 set_difference5.cpp)
add_test(test.alg.set_difference5, alg.set_difference5)

add_executable(alg.set_difference6 set_difference6.cpp)
add_test(test.alg.set_difference6, alg.set_difference6)

add_executable(alg.set_intersection1 set_intersection1.cpp)
add_test(test.alg.set_intersection1, alg.set_intersection1)

add_executable(alg.set_intersection2 set_intersection2.cpp)
add_test(test.alg.set_intersection2, alg.set_intersection2)

add_executable(alg.set_intersection3 set_intersection3.cpp)
add_test(test.alg.set_intersection3, alg.set_intersection3)

add_executable(alg.set_intersection4 set_intersection4.cpp)
add_test(test.alg.set_intersection4, alg.set_intersection4)

add_executable(alg.set_intersection5 set_intersection5.cpp)
add_test(test.alg.set_intersection5, alg.set_intersection5)

add_executable(alg.set_intersection6 set_intersection6.cpp)
add_test(test.alg.set_intersection6, alg.set_intersection6)

add_executable(alg.set_symmetric_difference1 set_symmetric_difference1.cpp)
add_test(test.alg.set_symmetric_difference1, alg.set_symmetric_difference1)

add_executable(alg.set_symmetric_difference2 set_symmetric_difference2.cpp)
add_test(test.alg.set_symmetric_difference2, alg.set_symmetric_difference2)

add_executable(alg.set_symmetric_difference3 set_symmetric_difference3.cpp)
add_test(test.alg.set_symmetric_difference3, alg.set_symmetric_difference3)

add_executable(alg.set_symmetric_difference4 set_symmetric_difference4.cpp)
add_test(test.alg.set_symmetric_difference4, alg.set_symmetric_difference4)

add_executable(alg.set_symmetric_difference5 set_symmetric_difference5.cpp)
add_test(test.alg.set_symmetric_difference5, alg.set_symmetric_difference5)

add_executable(alg.set_symmetric_difference6 set_symmetric_difference6.cpp)
add_test(test.alg.set_symmetric_difference6, alg.set_symmetric_difference6)

add_executable(alg.set_union1 set_union1.cpp)
add_test(test.alg.set_union1, alg.set_union1)

add_executable(alg.set_union2 set_union2.cpp)
add_test(test.alg.set_union2, alg.set_union2)

add_executable(alg.set_union3 set_union3.cpp)
add_test(test.alg.set_union3, alg.set_union3)

add_executable(alg.set_union4 set_union4.cpp)
add_test(test.alg.set_union4, alg.set_union4)

add_executable(alg.set_union5 set_union5.cpp)
add_test(test.alg.set_union5, alg.set_union5)

add_executable(alg.set_union6 set_union6.cpp)
add_test(test.alg.set_union6, alg.set_union6)

add_executable(alg.shuffle shuffle.cpp)
add_test(test.alg.shuffle, alg.shuffle)

add_executable(alg.sort sort.cpp)
add_test(test.alg.sort, alg.sort)

add_executable(alg.sort_heap sort_heap.cpp)
add_test(test.alg.sort_heap, alg.sort_heap)

add_executable(alg.stable_partition stable_partition.cpp)
add_test(test.alg.stable_partition, alg.stable_partition)

add_executable(alg.stable_sort stable_sort.cpp)
add_test(test.alg.stable_sort, alg.stable_sort)

add_executable(alg.swap_ranges swap_ranges.cpp)
add_test(test.alg.swap_ranges, alg.swap_ranges)

add_executable(alg.transform transform.cpp)
add_test(test.alg.transform, alg.transform)

add_executable(alg.unique unique.cpp)
add_test(test.alg.unique, alg.unique)

add_executable(alg.unique_copy unique_copy.cpp)
add_test(test.alg.unique_copy, alg.unique_copy)

add_executable(alg.upper_bound upper_bound.cpp)
add_test(test.alg.upper_bound, alg.upper_bound)

add_executable(alg.sort_n_with_buffer sort_n_with_buffer.cpp)
add_test(test.alg.sort_n_with_buffer alg.sort_n_with_buffer)

=== test/numeric/CMakeLists.txt ===
add_executable(num.accumulate accumulate.cpp)
add_test(test.num.accumulate num.accumulate)

add_executable(num.adjacent_difference adjacent_difference.cpp)
add_test(test.num.adjacent_difference num.adjacent_difference)

add_executable(num.inner_product inner_product.cpp)
add_test(test.num.inner_product num.inner_product)

add_executable(num.iota iota.cpp)
add_test(test.num.iota num.iota)

add_executable(num.partial_sum partial_sum.cpp)
add_test(test.num.partial_sum num.partial_sum)

=== test/utility/CMakeLists.txt ===
add_executable(utility.basic_iterator basic_iterator.cpp)
add_test(test.utility.basic_iterator utility.basic_iterator)

add_executable(utility.concepts concepts.cpp)
add_test(test.utility.concepts utility.concepts)

add_executable(utility.common_type common_type.cpp)
add_test(test.utility.common_type utility.common_type)

add_executable(utility.functional functional.cpp)
add_test(test.utility.functional utility.functional)

add_executable(utility.iterator iterator.cpp)
add_test(test.utility.iterator utility.iterator)

add_executable(utility.common_iterator common_iterator.cpp)
add_test(test.utility.common_iterator utility.common_iterator)

add_executable(utility.reverse_iterator reverse_iterator.cpp)
add_test(test.utility.reverse_iterator utility.reverse_iterator)

add_executable(utility.swap swap.cpp)
add_test(test.utility.swap utility.swap)

add_executable(utility.variant variant.cpp)
add_test(test.utility.variant utility.variant)

add_executable(utility.meta meta.cpp)
add_test(test.utility.meta utility.meta)

add_executable(utility.scope_exit scope_exit.cpp)
add_test(test.utility.scope_exit utility.scope_exit)

=== test/view/CMakeLists.txt ===
add_executable(view.adjacent_remove_if adjacent_remove_if.cpp)
add_test(test.view.adjacent_remove_if, view.adjacent_remove_if)

add_executable(view.all all.cpp)
add_test(test.view.all, view.all)

add_executable(view.any_view any_view.cpp)
add_test(test.view.any_view, view.any_view)

add_executable(view.bounded bounded.cpp)
add_test(test.view.bounded, view.bounded)

add_executable(view.cartesian_product cartesian_product.cpp)
add_test(test.view.cartesian_product, view.cartesian_product)

add_executable(view.chunk chunk.cpp)
add_test(test.view.chunk, view.chunk)

add_executable(view.concat concat.cpp)
add_test(test.view.concat, view.concat)

add_executable(view.const const.cpp)
add_test(test.view.const, view.const)

add_executable(view.counted counted.cpp)
add_test(test.view.counted, view.counted)

add_executable(view.cycle cycle.cpp)
add_test(test.view.cycle, view.cycle)

add_executable(view.delimit delimit.cpp)
add_test(test.view.delimit, view.delimit)

add_executable(view.drop drop.cpp)
add_test(test.view.drop, view.drop)

add_executable(view.drop_exactly drop_exactly.cpp)
add_test(test.view.drop_exactly, view.drop_exactly)

add_executable(view.drop_while drop_while.cpp)
add_test(test.view.drop_while, view.drop_while)

add_executable(view.generate generate.cpp)
add_test(test.view.generate, view.generate)

add_executable(view.generate_n generate_n.cpp)
add_test(test.view.generate_n, view.generate_n)

add_executable(view.group_by group_by.cpp)
add_test(test.view.group_by, view.group_by)

add_executable(view.indirect indirect.cpp)
add_test(test.view.indirect, view.indirect)

add_executable(view.intersperse intersperse.cpp)
add_test(test.view.intersperse, view.intersperse)

add_executable(view.iota iota.cpp)
add_test(test.view.iota, view.iota)

add_executable(view.join join.cpp)
add_test(test.view.join, view.join)

add_executable(view.linear_distribute linear_distribute.cpp)
add_test(test.view.linear_distribute, view.linear_distribute)

add_executable(view.map keys_value.cpp)
add_test(test.view.map, view.map)

add_executable(view.move move.cpp)
add_test(test.view.move, view.move)

add_executable(view.partial_sum partial_sum.cpp)
add_test(test.view.partial_sum, view.partial_sum)

add_executable(view.repeat repeat.cpp)
add_test(test.view.repeat, view.repeat)

add_executable(view.remove_if remove_if.cpp)
add_test(test.view.remove_if, view.remove_if)

add_executable(view.replace replace.cpp)
add_test(test.view.replace, view.replace)

add_executable(view.replace_if replace_if.cpp)
add_test(test.view.replace_if, view.replace_if)

add_executable(view.reverse reverse.cpp)
add_test(test.view.reverse, view.reverse)

add_executable(view.sample sample.cpp)
add_test(test.view.sample, view.sample)

add_executable(view.set_difference set_difference.cpp)
add_test(test.view.set_difference, view.set_difference)

add_executable(view.set_intersection set_intersection.cpp)
add_test(test.view.set_intersection, view.set_intersection)

add_executable(view.set_symmetric_difference set_symmetric_difference.cpp)
add_test(test.view.set_symmetric_difference, view.set_symmetric_difference)

add_executable(view.set_union set_union.cpp)
add_test(test.view.set_union, view.set_union)

add_executable(view.slice slice.cpp)
add_test(test.view.slice, view.slice)

add_executable(view.sliding sliding.cpp)
add_test(test.view.sliding, view.sliding)

add_executable(view.split split.cpp)
add_test(test.view.split, view.split)

add_executable(view.stride stride.cpp)
add_test(test.view.stride, view.stride)

add_executable(view.take take.cpp)
add_test(test.view.take, view.take)

add_executable(view.take_exactly take_exactly.cpp)
add_test(test.view.take_exactly, view.take_exactly)

add_executable(view.take_while take_while.cpp)
add_test(test.view.take_while, view.take_while)

add_executable(view.tokenize tokenize.cpp)
add_test(test.view.tokenize, view.tokenize)

add_executable(view.transform transform.cpp)
add_test(test.view.transform, view.transform)

add_executable(view.unique unique.cpp)
add_test(test.view.unique, view.unique)

add_executable(view.zip zip.cpp)
add_test(test.view.zip, view.zip)

=== debian/changelog ===
range-v3 (0.3.0-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 28 Jan 2018 02:39:03 +0300

range-v3 (0.3.0-1) unstable; urgency=low

  * Initial release (closes: #883235)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 07 Dec 2017 22:37:52 +0300

=== debian/control ===
Source: range-v3
Section: libdevel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: cmake (>=3.0), debhelper (>=10)
Build-Depends-Indep: doxygen-latex <!nodoc>
Standards-Version: 4.1.2
Homepage: https://github.com/ericniebler/range-v3
Vcs-Git: https://anonscm.debian.org/git/collab-maint/range-v3.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/range-v3.git

Package: librange-v3-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: librange-v3-doc
Description: range algorithms, views, and actions for C++11/14/17 - headers
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package contains headers of the library.

Package: librange-v3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: range algorithms, views, and actions for C++11/14/17 - documentation
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package ships HTML documentation of the library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# The build process is not needed to install headers, and we can skip a
# compilation given tests haven't performed.
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON

# Make the online documentation if the `nodoc` flag isn't specified.
override_dh_auto_build:
ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

# The `test` target doesn't compile tests by itself and fails if they aren't
# built before.
override_dh_auto_test:
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	dh_auto_build
	dh_auto_test
endif
